#include <gd.h>
#include <string.h> 
#include <stdlib.h> 
#include "pngout.h"


pngout::pngout(){
    printf("pngout obj created.\n");
    height=200;
    width=320;
    strcpy(filename,"out.png");
}

int pngout::get_height(){
    printf("getheight\n");
    return height;
}

int pngout::get_width(){
    printf("getwidth\n");
    return width;
}

int pngout::parse_inputline(char *name, char *value) {
    printf("pngout - %s: %s\n",name,value);
    if (strcmp(name, "height")==0) {
	height=atoi(value);
	return(0);
    }
    if (strcmp(name, "width")==0) {
	width=atoi(value);
	return(0);
    }
    if (strcmp(name, "file")==0) {
	strcpy(filename,value);
	return(0);
    }
    return(outputplugin::parse_inputline(name,value));
}


int pngout::output(gdImagePtr img) {
    FILE* file;
    if ((file=fopen(filename,"w"))==NULL){
	perror("pngout");
	exit(1);
    }
    gdImagePng(img, file);
    fclose(file);
}
