#include <string.h>
#include <stdio.h>
#include "strlens.h"

void input_pipe(int argc,char **argv,char *output);
void input_dummy(int argc,char **argv,char *output);
void input_tail(int argc,char **argv,char *output);

void parsetext(char* input, char* output) {
    //Powerfull tool to parse some textual input into some textual output.
    //At least, that's the plan :P
    char *argv[255];
    char buffer[STRLEN_TXTFROMINPUTMETHOD];
    int argc;
    int escaped=0;
    int i,j,k;
    j=0;
    printf("Parsetext: parsing %s\n",input);
    for (i=0; (i<strlen(input) && j<STRLEN_TXTFROMINPUTMETHOD); i++) {
	if (input[i]=='\\') {
	    escaped=1;
	} else {
	    if (escaped==1) {
		if (input[i]=='n') {
		    output[j++]=10;
		} else {
		    output[j++]=input[i];
		}
	    } else if (input[i]=='(') {
		printf("Found something to calculate.\n");
		argc=0;
		while (input[i]!=0 && input[i]!=')' ) {
		    i++;
		    k=0;
		    escaped=0;
		    while (((input[i]!=':' && input[i]!=0 && input[i]!=')') || escaped==1) && k<STRLEN_TXTFROMINPUTMETHOD) {
			if (input[i]=='\\' && escaped==0) {
			    escaped=1;
			    i++;
			} else {
			    escaped=0;
			    buffer[k++]=input[i++];
			}
		    }
		    buffer[k]=0;
		    argv[argc]=malloc(strlen(buffer)+1);
		    strcpy(argv[argc++],buffer);
		    printf("argv[%i]=%s\n",argc-1,argv[argc-1]);
		}
		argc--;
		if (strcmp(argv[0],"dummy")==0) input_dummy(argc, argv,buffer); else
		if (strcmp(argv[0],"pipe")==0) input_pipe(argc, argv,buffer); else
		if (strcmp(argv[0],"tail")==0) input_tail(argc, argv,buffer); else
		printf("Input method \"%s\" not found.\n",argv[0]);
		for (k=0; k<=argc; k++) free(argv[k]);
		k=0;
		while (buffer[k]!=0)
		    output[j++]=buffer[k++];
	    } else {
		output[j++]=input[i];
	    }
	    escaped=0;
	}
    }
    output[j]=0;
}


/*
The actual input filters.
They'll get called with ar
*/

void input_dummy(int argc,char **argv,char *output) {
    int i;
    printf("input_dummy called. Args:\n");
    for (i=0; i<=argc; i++) {
	printf("%s\n",argv[i]);
    }
    strcpy(output,"Dummy");
}

void input_pipe(int argc,char **argv,char *output) {
    FILE *f;
    int i=0;
    if ((f=popen(argv[1],"r"))==NULL) perror("input_pipe command");
    while (!feof(f) && i<STRLEN_TXTFROMINPUTMETHOD) {
	output[i++]=fgetc(f);
    }
    output[i]=0;
}

void input_tail(int argc,char **argv,char *output) {
    FILE *f;
    int i,j;
    int no=5;
    char *buff[255];
//    printf("argc=%i\n",argc);
    if (argc>1) no=atoi(argv[2]);
    for (i=0; i<no; i++) {
	buff[i]=malloc(STRLEN_INPUTLINELEN);
//	printf("Buff %i allocated.\n",i);
    }
//    printf("Buffer allocated.\n");
    if ((f=fopen(argv[1],"r"))==NULL) perror("input_tail file");
    i=0;
    while (!feof(f)) {
	fgets(buff[i++],STRLEN_INPUTLINELEN-1,f);
	buff[i-1][STRLEN_INPUTLINELEN]=0;
//	printf("Buff[%i]=%s",i-1,buff[i-1]);
	if (i==no) i=0;
    }
    strcpy(output,"");
    for (j=0; j<no; j++) {
	strcat(output,buff[i]);
	free(buff[i]);
	i++;
	if (i==no) i=0;
    }
}
