#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include "pngin.h"

int pngin::parse_inputline(char *name, char *value) {
    FILE *file;
    printf("pngin: %s: %s\n",name,value);
    if (strcmp(name, "file")==0) {
	if (file=fopen(value,"r")) {
	    pic=gdImageCreateFromPng(file);
	    fclose(file);
	    return(0);
	} else {
	    perror(value);
	    pic=gdImageCreate(1,1);
	    return(1);
	}
    }
    return(inputplugin::parse_inputline(name,value));
}

gdImagePtr* pngin::get_output() {
    return(&pic);
}

pngin::pngin() {
    printf("Created an yet uninitialized pngin obj\n");
}

pngin::~pngin() {
    gdImageDestroy(pic);
}
